var Configuration = function (model) {
  this.configuration = model;
  var myOther = {};
  var callbacks = model.callbacks;
  var otherIndex = 0;

  myOther = model.radio;
  for (var i = 0, len = myOther.length; i < len; i++) {
    if (myOther[i]["Other"])
      otherIndex = i;
  }

  this.set_configuration = function (conf) {
    configuration = conf;
  }

  this.get_configuration = function () {
    return configuration;
  }

  this.postConf = function (data) {
    return $.ajax({
      url: "http://" + window.location.hostname + ":" + window.location.port + "/ned/configuration",
      type: "POST",
      dataType: "json",
      data: JSON.stringify(data),
      success: function (code_html, statut) {
        console.log("conf saved");
        //set new conf
        callbacks = data.callbacks;
        //SAVED
        $.notify.addStyle('ned-conf', {
          html: "<div><span data-notify-text/>" + LBL_SAVED + "</div>",
          classes: {
            base: {
              "white-space": "nowrap",
              "background-color": "#8024FF",
              "padding": "30px",
              "margin-top": "100px",
              "margin-right": "50px",
              "border-style": "solid",
              "border-width": "1px",
              "border-color": "black",
              "color": "white"
            }
          }
        });
        $.notify(' ', {
          style: 'ned-conf',
          autoHideDelay: 3000,
          clickToHide: true
        });
      },
      error: function(xhr, textStatus, error) {
        console.log("Failed to save conf!");
      }
    });
  }

  this.getValuesRadio = function () {
    var radio = model.radio;
    if ($("#radio #operating-zone").val() == "Other") {
      radio = model.radio;
      radio[otherIndex].Other.uplink = $("#radio #uplink-frequency").val();
      radio[otherIndex].Other.downlink = $("#radio #downlink-frequency").val();
      radio[otherIndex].Other.bitRate = $("#radio #bit-rate").val();
    }
    return radio;
  }

  this.getValuesDevices = function () {
    var devices = [];
    for (i = 1; i <= model.MAX_DEVICES; i++) {
      if ($('#devices #device' + i + '').val() != "") {
        if (devices[i - 1] == undefined) {
          devices[i - 1] = { "name": "", "identifier": "" }
        }
        devices[i - 1].identifier = $('#devices #device' + i + '').val();
        devices[i - 1].name = $('#devices #nameDevice' + i + '').val();
      }
    }
    return devices;
  }
  // Edit a callback
  this.getValuesCallbacks = function (index) {
      callbacks[index].channel_ack = $("#callbacks .wrap-edit-callbacks #channel-ack").val();
      callbacks[index].downlinkData = $("#callbacks .wrap-edit-callbacks #downlink").val();
      callbacks[index].headers_status = [];
      $("[id^=rowNumStatus]").filter(function () {
        var id = this.id.substring(this.id.indexOf("_") + 1, this.id.length);
        if ($("#headers-status-" + id).val() != "" && $("#value-status-" + id).val() != "") {
          var header_status = { "header": "", "value": "" };
          header_status.header = $("#headers-status-" + id).val();
          header_status.value = $("#value-status-" + id).val();
          callbacks[index].headers_status.push(header_status);
        }
      });
      var enable = $("#enable_cb_" + index + " span").hasClass("icon-check") ? true : false;
      callbacks[index].enable = enable;
      callbacks[index].http_method_cb_data = $("#callbacks .wrap-edit-callbacks #http-method-data-cb").val();
      callbacks[index].content_type_data = $("#callbacks .wrap-edit-callbacks #content_type_data").val();
      callbacks[index].content_type_ack = $("#callbacks .wrap-edit-callbacks #content_type_ack").val();
      callbacks[index].content_type_status = $("#callbacks .wrap-edit-callbacks #content_type_status").val();
      callbacks[index].body_text_data = $("#callbacks .wrap-edit-callbacks #body_text_data").val();
      callbacks[index].body_text_ack = $("#callbacks .wrap-edit-callbacks #body_text_ack").val();
      callbacks[index].body_text_status = $("#callbacks .wrap-edit-callbacks #body_text_status").val();
      callbacks[index].http_method_cb_status = $("#callbacks .wrap-edit-callbacks #http-method-status").val();
      callbacks[index].send_duplicate = $("#callbacks .wrap-edit-callbacks #send-duplicate").prop("checked");
      callbacks[index].channel_status = $("#callbacks .wrap-edit-callbacks #channel-status").val();
      callbacks[index].headers_data = [];
      $("[id^=rowNumData]").filter(function () {
        var id = this.id.substring(this.id.indexOf("_") + 1, this.id.length);
        if ($("#headers-data-" + id).val() != "" && $("#value-headers-data-" + id).val() != "") {
          var header_data = { "header": "", "value": "" };
          header_data.header = $("#headers-data-" + id).val();
          header_data.value = $("#value-headers-data-" + id).val();
          callbacks[index].headers_data.push(header_data);
        }
      });
      callbacks[index].urlPattern_status = $("#callbacks .wrap-edit-callbacks #urlPattern-status").val();
      callbacks[index].channel_data = $("#callbacks .wrap-edit-callbacks #channel-data").val();
      callbacks[index].headers_ack = [];
      $("[id^=rowNumAck]").filter(function () {
        var id = this.id.substring(this.id.indexOf("_") + 1, this.id.length);
        if ($("#headers-ack-" + id).val() != "" && $("#value-ack-" + id).val() != "") {
          var header_ack = { "header": "", "value": "" };
          header_ack.header = $("#headers-ack-" + id).val();
          header_ack.value = $("#value-ack-" + id).val();
          callbacks[index].headers_ack.push(header_ack);
        }
      });
      callbacks[index].urlPattern_ack = $("#callbacks .wrap-edit-callbacks #urlPattern-ack").val();
      callbacks[index].type_data = $("#callbacks .wrap-edit-callbacks #type_data").val();
      callbacks[index].send = $("#callbacks .wrap-edit-callbacks #send").prop("checked");
      callbacks[index].http_method_cb_ack = $("#callbacks .wrap-edit-callbacks #http-method-data-ack").val();
      if (($("#callbacks .wrap-edit-callbacks #downlinkMode").val() == "DIRECT") || ($("#callbacks .wrap-edit-callbacks #downlinkMode").val() == "NO DOWNLINK")) {
        callbacks[index].cbType = "UPLINK";
      }
      else {
        callbacks[index].cbType = "BIDIR";
      }
      // callbacks[index].downlinkEnabled = false;
      //CUSTOM VARS
      callbacks[index].custom_variables_data = $("#callbacks .wrap-edit-callbacks #config-custom-payload-data").val();
      callbacks[index].urlPattern_data = $("#callbacks .wrap-edit-callbacks #urlPattern-data").val();
      if (callbacks[index].channel_data == "BATCH-URL") {
        callbacks[index].linePattern_data = $("#callbacks .wrap-edit-callbacks #linePattern-data").val();
      }
      if (callbacks[index].channel_ack == "BATCH-URL") {
        callbacks[index].linePattern_ack = $("#callbacks .wrap-edit-callbacks #linePattern-ack").val();
      }
      if (callbacks[index].channel_status == "BATCH-URL") {
        callbacks[index].linePattern_status = $("#callbacks .wrap-edit-callbacks #linePattern-status").val();
      }
      callbacks[index].send_status = $("#callbacks .wrap-edit-callbacks #send-status").prop("checked");
      callbacks[index].downlinkMode = $("#callbacks .wrap-edit-callbacks #downlinkMode").val();
      return callbacks;
   }
  // Create a new callback
  this.getValuesNewCallbacks = function () {
    var newCallbacks = {};
    newCallbacks.channel_ack = $("#callbacks .wrap-edit-callbacks #channel-ack").val();
    newCallbacks.downlinkData = $("#callbacks .wrap-edit-callbacks #downlink").val();
    newCallbacks.headers_status = [];
    $("[id^=rowNumStatus]").filter(function () {
      var id = this.id.substring(this.id.indexOf("_") + 1, this.id.length);
      if ($("#headers-status-" + id).val() != "" && $("#value-status-" + id).val() != "") {
        var header_status = { "header": "", "value": "" };
        header_status.header = $("#headers-status-" + id).val();
        header_status.value = $("#value-status-" + id).val();
        newCallbacks.headers_status.push(header_status);
      }
    });
    var enable = true;
    newCallbacks.enable = enable;
    newCallbacks.http_method_cb_data = $("#callbacks .wrap-edit-callbacks #http-method-data-cb").val();
    newCallbacks.content_type_data = $("#callbacks .wrap-edit-callbacks #content_type_data").val();
    newCallbacks.content_type_ack = $("#callbacks .wrap-edit-callbacks #content_type_ack").val();
    newCallbacks.content_type_status = $("#callbacks .wrap-edit-callbacks #content_type_status").val();
    newCallbacks.body_text_data = $("#callbacks .wrap-edit-callbacks #body_text_data").val();
    newCallbacks.body_text_ack = $("#callbacks .wrap-edit-callbacks #body_text_ack").val();
    newCallbacks.body_text_status = $("#callbacks .wrap-edit-callbacks #body_text_status").val();
    newCallbacks.http_method_cb_status = $("#callbacks .wrap-edit-callbacks #http-method-status").val();
    newCallbacks.send_duplicate = $("#callbacks .wrap-edit-callbacks #send-duplicate").prop("checked");
    newCallbacks.channel_status = $("#callbacks .wrap-edit-callbacks #channel-status").val();
    newCallbacks.headers_data = [];
    $("[id^=rowNumData]").filter(function () {
      var id = this.id.substring(this.id.indexOf("_") + 1, this.id.length);
      if ($("#headers-data-" + id).val() != "" && $("#value-headers-data-" + id).val() != "") {
        var header_data = { "header": "", "value": "" };
        header_data.header = $("#headers-data-" + id).val();
        header_data.value = $("#value-headers-data-" + id).val();
        newCallbacks.headers_data.push(header_data);
      }
    });
    newCallbacks.urlPattern_status = $("#callbacks .wrap-edit-callbacks #urlPattern-status").val();
    newCallbacks.channel_data = $("#callbacks .wrap-edit-callbacks #channel-data").val();
    newCallbacks.headers_ack = [];
    $("[id^=rowNumAck]").filter(function () {
      var id = this.id.substring(this.id.indexOf("_") + 1, this.id.length);
      if ($("#headers-ack-" + id).val() != "" && $("#value-ack-" + id).val() != "") {
        var header_ack = { "header": "", "value": "" };
        header_ack.header = $("#headers-ack-" + id).val();
        header_ack.value = $("#value-ack-" + id).val();
        newCallbacks.headers_ack.push(header_ack);
      }
    });
    newCallbacks.urlPattern_ack = $("#callbacks .wrap-edit-callbacks #urlPattern-ack").val();
    newCallbacks.type_data = $("#callbacks .wrap-edit-callbacks #type_data").val();
    newCallbacks.send = $("#callbacks .wrap-edit-callbacks #send").prop("checked");
    newCallbacks.http_method_cb_ack = $("#callbacks .wrap-edit-callbacks #http-method-data-ack").val();
    if (($("#callbacks .wrap-edit-callbacks #downlinkMode").val() == "DIRECT") || ($("#callbacks .wrap-edit-callbacks #downlinkMode").val() == "NO DOWNLINK")) {
      newCallbacks.cbType = "UPLINK";
    }
    else {
      newCallbacks.cbType = "BIDIR";
    }
    newCallbacks.downlinkEnabled = false;
    //CUSTOM VARS
    newCallbacks.custom_variables_data = $("#callbacks .wrap-edit-callbacks #config-custom-payload-data").val();
    newCallbacks.urlPattern_data = $("#callbacks .wrap-edit-callbacks #urlPattern-data").val();
    if (newCallbacks.channel_data == "BATCH-URL") {
      newCallbacks.linePattern_data = $("#callbacks .wrap-edit-callbacks #linePattern-data").val();
    }
    if (newCallbacks.channel_ack == "BATCH-URL") {
      newCallbacks.linePattern_ack = $("#callbacks .wrap-edit-callbacks #linePattern-ack").val();
    }
    if (newCallbacks.channel_status == "BATCH-URL") {
      newCallbacks.linePattern_status = $("#callbacks .wrap-edit-callbacks #linePattern-status").val();
    }
    newCallbacks.send_status = $("#callbacks .wrap-edit-callbacks #send-status").prop("checked");
    newCallbacks.downlinkMode = $("#callbacks .wrap-edit-callbacks #downlinkMode").val();
    return newCallbacks;
  }
}