var directResponseRegexp = "^((\\{time\\})|(\\{rssi\\})|(\\{tapid\\})|((0[xX])?[0-9a-fA-F]{0,16}))*$";
var dataList = ["device", "time", "duplicate", "snr", "station", "data", "avgSnr", "rssi", "seqNumber", "LQI"];
var customList = [];
var dataCustomList = [];
var ackList = ["device", "time", "duplicate", "snr", "rssi", "station", "avgSnr", "infocode"];
var statusList = ["device", "time", "duplicate", "snr", "station", "batt", "avgSnr", "lat", "lng", "rssi", "seqNumber", "temp"];
var batchList = ["batch"];
var custom_variable_regular_expressions = {
	"bool": /^[a-zA-ZÀ-ÿ0-9\#\-\_]*:([0-9]*|):bool(:[1-7]$|$)/,
	"char": /^[a-zA-ZÀ-ÿ0-9\#\-\_]*:([0-9]*|):char:[0-9]*(:[1-7]$|$)/,
	"int": /^[a-zA-ZÀ-ÿ0-9\#\-\_]*:([0-9]*|):int:([1-9]|[1-5][0-9]|6[0-4])(:little-endian|:big-endian)?(:[1-7]$|$)/,
	"uint": /^[a-zA-ZÀ-ÿ0-9\#\-\_]*:([0-9]*|):uint:([1-9]|[1-5][0-9]|6[0-4])(:little-endian|:big-endian)?(:[1-7]$|$)/,
	"float": /^[a-zA-ZÀ-ÿ0-9\#\-\_]*:([0-9]*|):float:(32|64)(:little-endian|:big-endian)?(:[1-7]$|$)/
}
var ctrlCallbacks = function (vModel) {
	nbRowTable = 0;
	var superIndex = null;
	var isNewCb = false;
	this.model = vModel;

	function printList(channelId, infoVariablesUrlId, infoVariablesLineId, CbList) {
		$(infoVariablesLineId).html(function () {
			var list = "Available variables: " + "<b>" + CbList + "</b>";
			return list;
		});
		if ($(channelId).val() === "BATCH-URL") {
			$(infoVariablesUrlId).html(function () {
				var list = "Available variables: " + "<b>" + batchList + "</b>";
				return list;
			});
		}
		else {
			$(infoVariablesUrlId).html(function () {
				var list = "Available variables: " + "<b>" + CbList + "</b>";
				return list;
			});
		}
	}

	function printCustomList() {
		$('#customVariables').html(function () {
			var list = "Custom variables: " + "<b>" + customList + "</b>";
			return list;
		});
	}

	function cleanForm() {
		var data = $('#type_data').attr("value");
		$('form[name="callback-form"] input[type=text]').val(null);
		$('[id^=rowNumData_]').remove();
		$('[id^=rowNumAck_]').remove();
		$('[id^=rowNumStatus_]').remove();
		$('#type_data').val(data);
	}

	function loadCallbacks() {
		$('#data-line').hide();
		$('#data-url').show();
		$('#ack-line').hide();
		$('#ack-url').show();
		$('#status-line').hide();
		$('#status-url').show();
		$('[id^=content_type_]').hide();
		$('[id^=bodyfield-]').hide();
		$('[id^=infoError]').hide();
		$('#infoComboBIDIR').hide();
		$('#infoComboDirect').hide();
		$('#infoDataPB').hide();

		printList('#channel-data', '#infoVariables', '#infoVariables-data-line', dataList);
		printList('#channel-ack', '#infoVariables-ack-url', '#infoVariables-ack-line', ackList);
		printList('#channel-status', '#infoVariables-status-url', '#infoVariables-status-line', statusList);
		printCustomList();
	}

	// Set default sample for new callback
	function setSelectDefaultValues() {
		$('#downlinkMode').val('NO DOWNLINK');
		$('#cbType').val('UPLINK');
		$('#channel-data').val('URL');
		$('#channel-ack').val('URL');
		$('#channel-status').val('URL');
		$('#http-method-data-cb').val('GET');
		$('#http-method-data-ack').val('GET');
		$('#http-method-status').val('GET');
		$("#cbType option[value='BIDIR']").attr("disabled", true);
		$("#downlink").attr("disabled", "disabled");
		if ($('#downlinkMode').val() === "CALLBACK" && dataList.lastIndexOf("ack") === -1) {
			dataList.push("ack");
		} else if (dataList.lastIndexOf("ack") !== -1) {
			dataList.pop();
		}
		dataCustomList = dataList.slice();
	}
	//Create a new callback
	$('.wrap-table-callbacks .btn').on('click', function (e) {
		e.preventDefault();
		isNewCb = true;
		cleanForm();
		$(this).parents('.wrap-table-callbacks').addClass('util-hide').next().removeClass('util-hide');
		eventCallback();
		setSelectDefaultValues();
		loadCallbacks();
		checkCustomVariables("#config-custom-payload-data", "#config-custom-ERROR-data");
	});
	//Add a new callback row in callbacks table
	function addCallbackRow(obj) {
		obj.callbacks.forEach(function (element, index) {
			if (element.channel_data !== 'URL') {
				var isBatchData = 'icon-check';
				var channelData = 'batch-url';
			} else {
				var isBatchData = 'icon-check-empty';
				var channelData = 'url';
			}
			if (element.channel_ack !== 'URL') {
				var isBatchAck = 'icon-check';
				var channelAck = 'batch-url';
			} else {
				var isBatchAck = 'icon-check-empty';
				var channelAck = 'url';
			}
			if (element.channel_status !== 'URL') {
				var isBatchStatus = 'icon-check';
				var channelStatus = 'batch-url';
			} else {
				var isBatchStatus = 'icon-check-empty';
				var channelStatus = 'url';
			}
			var isEnable = element.enable ? 'icon-check' : 'icon-check-empty';
			var isDownlink = element.downlinkEnabled ? 'icon-circle' : 'icon-circle-blank';
			var tableRow = '<tr><td class="downlinkElement" align="center">\
				<a id="downlink_cb_'+ index + '" href="javascript:void(0);" title="Downlink" class="downlink-button">\
				<span class="'+ isDownlink + ' icon-large editable"></span>\
				</a>\
				</td>\
				<td align="center">\
				<a id="enable_cb_'+ index + '" title="Enable" class="enable" href="javascript:void(0);">\
					<span class="icon-large editable '+ isEnable + '"></span>\
				  </a>\
				</td>\
				<td align="center">\
				<span style="margin-top: 10px" class="icon-globe icon-large icon-channel" title="'+ channelData + '"></span>\
				<span class="icon-globe icon-large icon-channel" title="'+ channelAck + '"></span>\
				<span class="icon-globe icon-large icon-channel" title="'+ channelStatus + '"></span>\
				</td>\
				<td class="cb-type" align="center">\
					<p>'+ element.cbType + '</p>\
					<p >ACK</p>\
					<p >STATUS</p>\
				</td>\
				<td align="center">\
				  <p style="margin-top: 10px" class="'+ isBatchData + ' icon-large icon-batch"></p>\
				  <p class="'+ isBatchAck + ' icon-large icon-batch"></p>\
				  <p class="'+ isBatchStatus + ' icon-large icon-batch"></p>\
				</td>\
				<td>\
				  <div class="column-text-ellipsis url-patterns" title="'+ element.urlPattern_data + '">\
					<p>'+ element.urlPattern_data + '</p>\
				  </div>\
				  <div class="column-text-ellipsis url-patterns" title="'+ element.urlPattern_ack + '">\
					<p>'+ element.urlPattern_ack + '</p>\
				  </div>\
				  <div class="column-text-ellipsis url-patterns" title="'+ element.urlPattern_status + '">\
					<p>'+ element.urlPattern_status + '</p>\
				  </div>\
				</td>\
				<td align="center">\
				  <a id="edit_cb_'+ index + '" href="javascript:void(0)" title="edit callback" class="edit-button">\
					<span class="icon-edit icon-large editable"></span>\
				  </a>\
				</td>\
				<td align="center">\
				  <a id="delete_cb_'+ index + '" href="javascript:void(0);" title="Delete" class="delete-button">\
					<span class="icon-remove icon-large editable"></span>\
				  </a>\
				</td>\
			  </tr>';
			$('#callbacks table tbody').append(tableRow);
			if (element.cbType === 'UPLINK' || element.urlPattern_data === "") {
				$('#downlink_cb_' + index).children().css('display', 'none');
			}
			nbRowTable += 1;
		});
		isDownlink(obj);
		editCallback(obj);
		isEnable(obj);
		deleteCallback(obj);
	}
	//test to put edit as function
	function editCallback(obj) {
		$(".wrap-table-callbacks .table .edit-button").on('click', function (e) {
			e.preventDefault();
			var index = this.id.split("_");
			superIndex = index[2];
			SetCookie("where", "callbacks_edit");
			SetCookie("callbackID", index[2]);
			if (obj.callbacks[superIndex].downlinkMode === "CALLBACK") {
				if (dataList.lastIndexOf("ack") === -1) {
					dataList.push("ack");
				}
			} else {
				if (dataList.lastIndexOf("ack") !== -1) {
					dataList.pop();
				}
			}
			cleanForm();
			$(this).parents('.wrap-table-callbacks').addClass('util-hide').next().removeClass('util-hide');
			loadCallbacks();
			eventCallback();
			setValuesCallbacks(index[2]);
			checkCustomVariables("#config-custom-payload-data", "#config-custom-ERROR-data");
		});
	}
	//add the listeners to callback page
	function eventCallback() {
		changeChannelData();
		changeChannelAck();
		changeChannelStatus();
		changeHttpMethodData();
		changeHttpMethodAck();
		changeHttpMethodStatus();
		changeDownlinkMode();
		updateCbType();
	}
	//combo type data callback
	function updateCbType() {
		$("#cbType").on('click', function (e) {
			e.preventDefault();
			if ($("#downlinkMode").val() == "DIRECT" && $("#cbType").val() == "UPLINK") {
				$("#downlink").removeAttr("disabled");
			}
		});
	}
	//delete callback
	function deleteCallback(output) {
		$(".wrap-table-callbacks .table .delete-button").on('click', function (e) {
			e.preventDefault();
			if (confirm(LBL_DEL_CB)) {
				var index = this.id.split("_");
				superIndex = index[2];
				output.callbacks.splice(superIndex, 1);
				vModel.postConf(output);
				nbRowTable -= 1;
				SetCookie("callbackID", index[2]);
				$('.table tbody tr').remove();
				get_conf(function (output) {
					set_conf(output);
					addCallbackRow(output);
				});
			}
		});
	}
	//Enable/disable callback
	function isEnable(output) {
		$('.enable').on('click', function (e) {
			e.preventDefault();
			if (confirm(LBL_ENABLE_CB)) {
				var btn = $(this),
					status = btn.children().hasClass('icon-check') ? true : false,
					index = btn.attr('id').split('_'),
					change = status ? false : true;
				output.callbacks[index[2]].enable = change;
				vModel.postConf(output);
				if (status)
					btn.children().removeClass('icon-check').addClass('icon-check-empty');
				else
					btn.children().removeClass('icon-check-empty').addClass('icon-check');
			}
		});
	}
	//Enable/disable callback BIDIR downlink mode
	function isDownlink(output) {
		$('.downlink-button').on('click', function (e) {
			e.preventDefault();
			if (confirm(LBL_DOWN_CB)) {
				var btn = $(this),
					allBtn = $('.icon-circle'),
					status = btn.children().hasClass('icon-circle') ? true : false,
					index = btn.attr('id').split('_'),
					change = status ? false : true;
				output.callbacks.forEach(function (element) {
					element.downlinkEnabled = false;
				});
				output.callbacks[index[2]].downlinkEnabled = change;
				vModel.postConf(output);
				allBtn.removeClass('icon-circle').addClass('icon-circle-blank');
				if (status)
					btn.children().removeClass('icon-circle').addClass('icon-circle-blank');
				else
					btn.children().removeClass('icon-circle-blank').addClass('icon-circle');
			}
		});
	}
	// load table callbacks content
	function loadTableCallbacks(conf) {
		$('.pane').hide();
		$('.wrap-edit-callbacks').addClass('util-hide').prev().removeClass('util-hide');
		$('#left_menu ul li').removeClass("left-nav-selected");
		$('ul .callbacksLi').addClass("left-nav-selected");
		$('#callbacks').show();
		if (typeof nbRowTable === 'undefined' || nbRowTable < conf.callbacks.length) {
			addCallbackRow(conf);
		}
	}
	// click on the left menu (CALLBACK)
	$('#link_callbacks').on('click', function (e) {
		e.preventDefault();
		isNewCb = false;
		get_conf(function (output) {
			set_conf(output);
			var ret = control_before_quit(output, document.cookie);
			if ((ret && confirm(LBL_NOT_SAVED)) || !ret) {
				SetCookie("where", "callbacks");
				loadTableCallbacks(output);
			}
		});
	});
	//check downlink data in hex
	$("#downlink").focusout(function () {
		var isValid = is_response_ok($("#downlink").val());
		if (!isValid && $("#downlinkMode").val() == "DIRECT") {
			$("#infoDataPB").show();
		} else {
			$("#infoDataPB").hide();
		}
	});

	//check http(s) format
	function getPattern(href) {
		var match = href.match(/^(https?:)\/\//);
		return match;
	}

	//display the error http message
	function displayErrorHttp(href, spanToDisplay) {
		if (href == null) {
			$(spanToDisplay).show();
			$.notify.addStyle('ned', {
				html: "<div><span data-notify-text/>" + "Please use " + "<b>" + "http(s)://" + "</b>" + " format" + "</div>",
				classes: {
					base: {
						"white-space": "nowrap",
						"background-color": "#FA5537",
						"padding": "30px",
						"margin-top": "100px",
						"border-style": "solid",
						"border-width": "1px",
						"border-color": "black",
						"color": "white"
					}
				}
			});
			$.notify(' ', {
				style: 'ned',
				autoHideDelay: 12000
			});
		}
		else
			$(spanToDisplay).hide();
	}

	//check validity for url patterns
	function checkHttp(pattern, messageError) {
		if ($(pattern).val() !== "" ) {
			var match = pattern.match(/^(#url)/);
			if (match != null) {
				var href = getPattern($(pattern).val());
				displayErrorHttp(href, messageError);
			}
		}
	}

	//check focus on pattern to dipslay error
	function checkPatternFocus(pattern, list, messageError) {
		$(pattern).unbind('focusout');
		$(pattern).bind('focusout', function () {
			// Checks to see if all of the variables declared are ok!
			var errorTab = checkVariables(list, $(pattern).val());
			// Then it checks if the user is using the correct http format!
			checkHttp(pattern, messageError);
			// If the error tab has a non zero length (ie: if checkVariables has found an error)
			// Then we spit out an error message displaying the variables that are incorrect!
			if (errorTab.length != 0) {
				for (i = 0; i <= errorTab.length - 1; i++) {
					if (errorTab[i] == "")
						errorTab[i] = "{empty}";
				}
				$(messageError).show();
				displayErrorMsg(errorTab);
			}
			else {
				$(messageError).hide();
			}
		})
	}
	function updateDataCustomList() {
		dataCustomList = dataList.slice();
		customList.forEach(function (element, index) {
			dataCustomList.unshift(element);
		});
	}
	//Used only for custom variables
	//returns false if there's an error because of the silly isError var
	function checkCustomVariables(pattern, messageError) {
		customList = [];
		printCustomList();
		if ($(pattern).val() === "" || typeof pattern === 'undefined') {
			//No special custom variables, just return
			$(messageError).hide();
			patternFocus();
			return false;
		}
		var custom_variable = $(pattern).val().trim().split(/\s+/);
		var ok_field_def = [];
		var ok_field_def_counter = 0;
		for (field_def in custom_variable) {
			for (reg_expression in custom_variable_regular_expressions) {
				if (custom_variable_regular_expressions[reg_expression].test(custom_variable[field_def])) {
					ok_field_def.push(custom_variable[field_def]);
					ok_field_def_counter++;
					// Add the name of this ok variable to the dataList
					var variable_to_add = custom_variable[field_def].split(":");
					if (customList.length === 0) {
						customList.push("customData#" + variable_to_add[0]);
					}
					else {
						var len = customList.length;
						var added = false;
						var found = false;
						for (i = 0; i < len; i++) {
							while (customList[i]) {
								if (customList[i] === "customData#" + variable_to_add[0]) {
									found = true;
								}
								i += 1;
							}
							if (!found && !added) {
								customList.push("customData#" + variable_to_add[0]);
								added = true;
							}
						}
					}
				}
			}
		}
		if (ok_field_def_counter !== custom_variable.length) {
			//Oh dear! Seems like one of the expressions was incorrect!
			//Time to check out which one was incorrect!
			for (field_def in custom_variable) {
				if (ok_field_def.indexOf(custom_variable[field_def]) === -1) {
					var error_message = "The following custom variable definition is incorrect:" + custom_variable[field_def];
					$(messageError).html(error_message);
					$(messageError).show().css('color', '#FA5537');

					$.notify.addStyle('ned', {
						html: "<div><span data-notify-text/>" + "Please use custom variable grammar" + "</div>",
						classes: {
							base: {
								"white-space": "nowrap",
								"background-color": "#FA5537",
								"padding": "30px",
								"margin-top": "100px",
								"border-style": "solid",
								"border-width": "1px",
								"border-color": "black",
								"color": "white"
							}
						}
					});
					$.notify(' ', {
						style: 'ned',
						autoHideDelay: 12000
					});
					return true
				}
			}
		}
		else {
			//All is good! Let's hide the messageError just in case it was on!
			$(messageError).hide();
			$('#customVariables').html(function () {
				var list = "Custom variables: " + "<b>" + customList + "</b>";
				return list;
			});
			updateDataCustomList();
			patternFocus();
			return false;
		}
	}

	function checkPatternFocusCustomVariables(pattern, messageError) {
		$(pattern).unbind('focusout');
		$(pattern).bind('focusout', function () {
			checkCustomVariables(pattern, messageError);
		});
	}

	function patternFocus() {
		if ($('#channel-data').val() !== "BATCH-URL") {
			checkPatternFocus("#urlPattern-data", dataCustomList, "#infoErrorUrl-data");
		}
		else {
			checkPatternFocus("#urlPattern-data", batchList, "#infoErrorUrl-data");
		}
		if ($('#channel-ack').val() !== "BATCH-URL") {
			checkPatternFocus("#urlPattern-ack", ackList, "#infoErrorUrl-ack");
		}
		else {
			checkPatternFocus("#urlPattern-ack", batchList, "#infoErrorUrl-ack");
		}
		if ($('#channel-status').val() !== "BATCH-URL") {
			checkPatternFocus("#urlPattern-status", statusList, "#infoErrorUrl-status");
		}
		else {
			checkPatternFocus("#urlPattern-status", batchList, "#infoErrorUrl-status");
		}

		checkPatternFocusCustomVariables("#config-custom-payload-data", "#config-custom-ERROR-data");
		checkPatternFocus("#linePattern-data", dataCustomList, "#infoErrorLine-data");
		checkPatternFocus("#linePattern-ack", ackList, "#infoErrorLine-ack");
		checkPatternFocus("#linePattern-status", statusList, "#infoErrorLine-status");
	}

	// choice control (callback page)
	function changeChannelData() {
		$("#channel-data").unbind("change").change(function () {
			if ($("#channel-data").val() === "URL") {
				checkPatternFocus("#urlPattern-data", dataCustomList, "#infoErrorUrl-data");
				$('#data-url').show();
				$("#infoVariables").html(function () {
					var list = "Available variables: " + "<b>" + dataList + "</b>";
					return list;
				});
				if ($("#linePattern-data").val() !== null)
					$("#linePattern-data").val("");
				$('#data-line').hide();
				$("#http-method-data-cb").show();
				$("#http-method-data-cb-label").show();
				$("#body_text_data").show();
				$("#bodyTemplate-data").show();
				$("#content_type_data").show();
				$("#content_type_data-label").show();
				$("#http-method-data-cb").change();//to refresh the list and avoid a bad display
			} else {
				checkPatternFocus("#urlPattern-data", batchList, "#infoErrorUrl-data");
				$("#infoVariables").html(function () {
					var list = "Available variables: " + "<b>" + batchList + "</b>";
					return list;
				});
				$("#http-method-data-cb").hide();
				$("#http-method-data-cb-label").hide();
				$('#data-url').show();
				$('#data-line').show();
				$("#body_text_data").hide();
				$("#bodyTemplate-data").hide();
				$("#content_type_data").hide();
				$("#content_type_data-label").hide();
				$("#http-method-data-cb").hide();
			}
		});
	}
	// choice control (callback page)
	function changeChannelAck() {
		$("#channel-ack").unbind("change").change(function () {
			if ($("#channel-ack").val() === "URL") {
				checkPatternFocus("#urlPattern-ack", ackList, "#infoErrorUrl-ack");
				$("#infoVariables-ack-url").html(function () {
					var list = "Available variables: " + "<b>" + ackList + "</b>";
					return list;
				});
				if ($("#linePattern-ack").val() !== null)
					$("#linePattern-ack").val("");
				$('#ack-url').show();
				$('#ack-line').hide();
				$("#http-method-data-ack").show();
				$("#http-method-ack-label").show();
				$("#body_text_ack").show();
				$("#bodyTemplate-ack").show();
				$("#content_type_ack").show();
				$("#content_type_ack-label").show();
				$("#http-method-data-ack").change();
			} else {
				checkPatternFocus("#urlPattern-ack", batchList, "#infoErrorUrl-ack");
				$("#infoVariables-ack-url").html(function () {
					var list = "Available variables: " + "<b>" + batchList + "</b>";
					return list;
				})
				$('#ack-url').show();
				$('#ack-line').show();
				$("#http-method-data-ack").hide();
				$(" #http-method-ack-label").hide();
				$("#body_text_ack").hide();
				$("#bodyTemplate-ack").hide();
				$("#content_type_ack").hide();
				$("#content_type_ack-label").hide();
			}
		});
	}
	// add line pattern(callback page)
	function changeChannelStatus() {
		$("#channel-status").unbind("change").change(function () {
			if ($("#channel-status").val() === "URL") {
				checkPatternFocus("#urlPattern-status", statusList, "#infoErrorUrl-status");
				$("#infoVariables-status-url").html(function () {
					var list = "Available variables: " + "<b>" + statusList + "</b>";
					return list;
				});
				if ($("#linePattern-status").val() !== null)
					$("#linePattern-status").val("");
				$('#status-url').show();
				$('#status-line').hide();
				$("#http-method-status").show();
				$("#http-method-status-label").show();
				$("#body_text_status").show();
				$("#bodyTemplate-status").show();
				$("#content_type_status").show();
				$("#content_type_status-label").show();
				$("#http-method-status").change();
			} else {
				checkPatternFocus("#urlPattern-status", batchList, "#infoErrorUrl-status");
				$("#infoVariables-status-url").html(function () {
					var list = "Available variables: " + "<b>" + batchList + "</b>";
					return list;
				});
				$('#status-url').show();
				$('#status-line').show();
				$("#callbacks #http-method-status").hide();
				$("#callbacks #http-method-status-label").hide();
				$("#body_text_status").hide();
				$("#bodyTemplate-status").hide();
				$("#content_type_status").hide();
				$("#content_type_status-label").hide();
			}

		});
	}
	/*
	 * Controls bodyTemplate-data depending of which method
	 * has been chosen in http-method-data-cb list
	 */
	function changeHttpMethodData() {
		$("#http-method-data-cb").unbind("change").change(function () {
			if ($("#http-method-data-cb").val() == "GET") {
				$("#bodyfield-data").hide();
				$("#content_type_data").hide();
				$("#content_type_data-label").hide();
			}
			else {
				$("#bodyfield-data").show();
				$("#content_type_data").show();
				$("#content_type_data-label").show();
			}
		});
	}
	/*
	* Controls bodyTemplate-ack depending of which method
	* has been chosen in http-method-data-ack list
	*/
	function changeHttpMethodAck() {
		$("#http-method-data-ack").unbind("change").change(function () {
			if ($("#http-method-data-ack").val() == "GET") {
				$("#bodyfield-ack").hide();
				$("#content_type_ack").hide();
				$("#content_type_ack-label").hide();
			}
			else {
				$("#bodyfield-ack").show();
				$("#content_type_ack").show();
				$("#content_type_ack-label").show();
			}
		});
	}
	/*
	* Controls bodyTemplate-status depending of which method
	* has been chosen in http-method-status list
	*/
	function changeHttpMethodStatus() {
		$("#http-method-status").unbind("change").change(function () {
			if ($("#http-method-status").val() == "GET") {
				$("#bodyfield-status").hide();
				$("#content_type_status").hide();
				$("#content_type_status-label").hide();
			}
			else {
				$("#bodyfield-status").show();
				$("#content_type_status").show();
				$("#content_type_status-label").show();
			}
		});
	}
	// control choice and add help message
	function changeDownlinkMode() {
		$("#downlinkMode").unbind("change").change(function () {
			var item = ["#infoVariables", "#infoVariables-data-line"];
			while (dataList.lastIndexOf("ack") !== -1)
				dataList.pop();
			if (($("#downlinkMode").val() == "DIRECT")) {
				$("#cbType option[value='UPLINK']").removeAttr("disabled");
				$("#cbType option[value='BIDIR']").removeAttr("selected");
				$("#cbType option[value='BIDIR']").attr("disabled", false);
				$("#cbType option[value='BIDIR']").attr("disabled", "disabled");
				$("#cbType option[value='UPLINK']").prop("selected", true);
				$("#choice_callback").hide();
				$("#downlink").val("");
				$("#downlink").removeAttr("disabled");
				if ($("#channel-data").val() !== "BATCH-URL") {
					for (i = 0; i < item.length; i++) {
						$(item[i]).html(function () {
							var list = "Available variables: " + "<b>" + dataList + "</b>";
							return list;
						});
					}
				}
				else {
					$('#infoVariables').html(function () {
						var list = "Available variables: " + "<b>" + batchList + "</b>";
						return list;
					});
					$('#infoVariables-data-line').html(function () {
						var list = "Available variables: " + "<b>" + dataList + "</b>";
						return list;
					});
				}
			} else {
				$("#downlink").val("");
				$("#downlink").attr("disabled", "disabled");
				if ($("#downlinkMode").val() == "NO DOWNLINK") {
					$("#cbType option[value='UPLINK']").removeAttr("disabled");
					$("#cbType option[value='BIDIR']").removeAttr("selected");
					$("#cbType option[value='BIDIR']").attr("disabled", false);
					$("#cbType option[value='BIDIR']").attr("disabled", "disabled");
					$("#cbType option[value='UPLINK']").prop("selected", true);
					if ($("#channel-data").val() !== "BATCH-URL") {
						for (i = 0; i < item.length; i++) {
							$(item[i]).html(function () {
								var list = "Available variables: " + "<b>" + dataList + "</b>";
								return list;
							});
						}
					}
					else {
						$('#infoVariables').html(function () {
							var list = "Available variables: " + "<b>" + batchList + "</b>";
							return list;
						});
						$('#infoVariables-data-line').html(function () {
							var list = "Available variables: " + "<b>" + dataList + "</b>";
							return list;
						});
					}
				} else {
					$("#cbType option[value='BIDIR']").removeAttr("disabled");
					$("#cbType option[value='UPLINK']").removeAttr("selected");
					$("#cbType option[value='UPLINK']").attr("disabled", false);
					$("#cbType option[value='UPLINK']").attr("disabled", "disabled");
					$("#cbType option[value='BIDIR']").prop("selected", true);
					dataList.push("ack");
					if ($("#channel-data").val() !== "BATCH-URL") {
						for (i = 0; i < item.length; i++) {
							$(item[i]).html(function () {
								var list = "Available variables: " + "<b>" + dataList + "</b>";
								return list;
							});
						}
					}
					else {
						$('#infoVariables').html(function () {
							var list = "Available variables: " + "<b>" + batchList + "</b>";
							return list;
						});
						$('#infoVariables-data-line').html(function () {
							var list = "Available variables: " + "<b>" + dataList + "</b>";
							return list;
						});
					}
				}
				$("#infoComboDirect").hide();
				$("#infoComboBIDIR").hide();
				$("#infoDataPB").hide();
				$("#choice_callback").show();
			}
			updateDataCustomList();
			patternFocus();
		});
	}
	function setValuesCallbacks(index) {
		var items = this.model;
		$("#callbacks #downlinkMode").val(items.callbacks[index].downlinkMode);
		if ($("#callbacks #downlinkMode").val() == "CALLBACK" || $("#callbacks #downlinkMode").val() == "NO DOWNLINK") {
			$("#callbacks #downlink").val('');
			$("#callbacks #downlink").attr("disabled", "disabled");
		} else {
			$("#callbacks #downlink").removeAttr("disabled");
			$("#callbacks #downlink").val(items.callbacks[index].downlinkData);
		}
		if ($("#callbacks #downlinkMode").val() == "DIRECT" && $("#callbacks #downlink").val() == "") {
			$("#infoDataPB").show();
		}
		if ($("#callbacks #downlinkMode").val() == "DIRECT") {
			$("#choice_callback").hide();
		} else {
			$("#choice_callback").show();
		}
		// control choice following conf
		if ($("#downlinkMode").val() == "DIRECT" || $("#downlinkMode").val() == "NO DOWNLINK") {
			$("#cbType option[value='BIDIR']").attr("disabled", true);
		}
		if ($("#downlinkMode").val() == "CALLBACK") {
			$("#cbType option[value='UPLINK']").attr("disabled", true);
		}
		$("#callbacks #http-method-data-cb").val(items.callbacks[index].http_method_cb_data);
		$("#callbacks #http-method-data-cb").change();

		//  //DATA CALLBACK
		$("#callbacks #type_data").val(items.callbacks[index].type_data);
		$("#callbacks #cbType").val(items.callbacks[index].cbType);
		$("#callbacks #channel-data").val(items.callbacks[index].channel_data);
		$("#callbacks #content_type_data").val(items.callbacks[index].content_type_data);
		$("#callbacks #body_text_data").val(items.callbacks[index].body_text_data);
		$("#callbacks #channel-data").change();
		$("#config-custom-payload-data").val(items.callbacks[index].custom_variables_data);
		if (items.callbacks[index].send_duplicate == true) {
			$("#callbacks #send-duplicate").attr("checked", "checked");
		}
		$("#callbacks #urlPattern-data").val(items.callbacks[index].urlPattern_data);
		if ($("#callbacks #channel-data").val() == "BATCH-URL") {
			$("#callbacks #linePattern-data").val(items.callbacks[index].linePattern_data);
		}
		for (var i in items.callbacks[index].headers_data) {
			var row = "<div id='rowNumData_" + rowNum + "'><label>Headers</label><input id='headers-data-" + rowNum + "' name='headers-data-" + rowNum + "' value='" + items.callbacks[index].headers_data[i].header + "' type='text'/><input id='value-headers-data-" + rowNum + "' name='value-headers-data' value='" + items.callbacks[index].headers_data[i].value + "' type='text'><button id='delRowData-" + rowNum + "'>Del</button></div>";
			rowNum++;
			$('#add_header_data').append(row);
			$("button[id^=delRowData-]").on('click', function (e) {
				e.preventDefault();
				$(this).parent().remove();
			});
		}
		for (var i in items.callbacks[index].headers_ack) {
			var row = "<div id='rowNumAck_" + rowNumAck + "'><label>Headers</label><input id='headers-ack-" + rowNumAck + "' name='headers-ack-" + rowNumAck + "' value='" + items.callbacks[index].headers_ack[i].header + "' type='text'/><input id='value-ack-" + rowNumAck + "' name='value-ack' value='" + items.callbacks[index].headers_ack[i].value + "' type='text'><button id='delRowAck-" + rowNumAck + "'>Del</button></div>";
			rowNumAck++;
			$('#add_header_ack').append(row);
			$("button[id^=delRowAck-]").on('click', function (e) {
				e.preventDefault();
				$(this).parent().remove();
			});
		}
		for (var i in items.callbacks[index].headers_status) {
			var row = "<div id='rowNumStatus_" + rowNumStatus + "'><label>Headers</label><input id='headers-status-" + rowNumStatus + "' name='headers-status-" + rowNumStatus + "' value='" + items.callbacks[index].headers_status[i].header + "' type='text'/><input id='value-status-" + rowNumStatus + "' name='value-status' value='" + items.callbacks[index].headers_status[i].value + "' type='text'><button id='delRowStatus-" + rowNumStatus + "'>Del</button></div>";
			rowNumStatus++;
			$('#add_header_status').append(row);
			$("button[id^=delRowStatus-]").on('click', function (e) {
				e.preventDefault();
				$(this).parent().remove();
			});
		}
		//  //ACK
		$("#callbacks #http-method-data-ack").val(items.callbacks[index].http_method_cb_ack);
		$("#callbacks #http-method-data-ack").change();
		$("#callbacks #channel-name-ack").val(items.callbacks[index].channel_name_ack);
		$("#callbacks #channel-ack").val(items.callbacks[index].channel_ack);
		$("#callbacks #content_type_ack").val(items.callbacks[index].content_type_ack);
		$("#callbacks #body_text_ack").val(items.callbacks[index].body_text_ack);
		$("#callbacks #channel-ack").change();
		if (items.callbacks[index].channel_ack == "BATCH-URL") {
			$("#callbacks #linePattern-ack").val(items.callbacks[index].linePattern_ack);
		}
		if (items.callbacks[index].send == true) {
			$("#callbacks #send").attr("checked", "checked");
		}
		$("#callbacks #urlPattern-ack").val(items.callbacks[index].urlPattern_ack);
		//  //STATUS
		$("#callbacks #content_type_status").val(items.callbacks[index].content_type_status);
		$("#callbacks #body_text_status").val(items.callbacks[index].body_text_status);
		$("#callbacks #channel-name-status").val(items.callbacks[index].channel_name_status);
		$("#callbacks #channel-status").val(items.callbacks[index].channel_status);
		$("#callbacks #channel-status").change();
		$("#callbacks #http-method-status").val(items.callbacks[index].http_method_cb_status);
		$("#callbacks #http-method-status").change();
		if (items.callbacks[index].channel_status == "BATCH-URL") {
			$("#callbacks #http-post-status").attr("disabled", "disabled");
			$("#callbacks #linePattern-status").val(items.callbacks[index].linePattern_status);
		}
		if (items.callbacks[index].send_status == true) {
			$("#callbacks #send-status").attr("checked", "checked");
		}
		$("#callbacks #send-status").val(items.callbacks[index].send_status);
		$("#callbacks #urlPattern-status").val(items.callbacks[index].urlPattern_status);
	}

	var rowNum = 1;
	var rowNumAck = 1;
	var rowNumStatus = 1;
	// Add or del headers
	$("#addRowData").on('click', function (e) {
		e.preventDefault();
		if ($("#headers-data").val() != "" && $("#value-headers-data").val() != "") {
			var row = "<div id='rowNumData_" + rowNum + "'><label>Headers</label><input id='headers-data-" + rowNum + "' name='headers-data-" + rowNum + "' value='" + $("#headers-data").val() + "' type='text'/><input id='value-headers-data-" + rowNum + "' name='value-headers-data' value='" + $("#value-headers-data").val() + "' type='text'/><button id='delRowData-" + rowNum + "'>Del</button></div>";
			rowNum++;
			$('#add_header_data').append(row);
			$("#headers-data").val("");
			$("#value-headers-data").val("");
			$("button[id^=delRowData-]").on('click', function (e) {
				e.preventDefault();
				$(this).parent().remove();
			});
		} else {
			alert('please fill the headers fields');
		}
	});
	$("#addRowAck").on('click', function (e) {
		e.preventDefault();
		if ($("#headers-ack").val() != "" && $("#value-ack").val() != "") {
			var row = "<div id='rowNumAck_" + rowNumAck + "'><label>Headers</label><input id='headers-ack-" + rowNumAck + "' name='headers-ack-" + rowNumAck + "' value='" + $("#headers-ack").val() + "' type='text'/><input id='value-ack-" + rowNumAck + "' name='value-ack' value='" + $("#value-ack").val() + "' type='text'><button id='delRowAck-" + rowNumAck + "'>Del</button></div>";
			rowNumAck++;
			$('#add_header_ack').append(row);
			$("#headers-ack").val("");
			$("#value-ack").val("");
			$("button[id^=delRowAck-]").on('click', function (e) {
				e.preventDefault();
				$(this).parent().remove();
			});
		} else {
			alert('please fill the headers fields');
		}
	});
	$("#addRowStatus").on('click', function (e) {
		e.preventDefault();
		if ($("#headers-status").val() != "" && $("#value-status").val() != "") {
			var row = "<div id='rowNumStatus_" + rowNumStatus + "'><label>Headers</label><input id='headers-status-" + rowNumStatus + "' name='headers-status-" + rowNumStatus + "' value='" + $("#headers-status").val() + "' type='text'/><input id='value-status-" + rowNumStatus + "' name='value-status' value='" + $("#value-status").val() + "' type='text'><button id='delRowStatus-" + rowNumStatus + "'>Del</button></div>";
			rowNumStatus++;
			$('#add_header_status').append(row);
			$("#headers-status").val("");
			$("#value-status").val("");
			$("button[id^=delRowStatus-]").on('click', function (e) {
				e.preventDefault();
				$(this).parent().remove();
			});
		} else {
			alert('please fill the headers fields');
		}
	});
	function set_conf(conf) {
		this.model = conf;
	}
	// Check downlink data
	function is_response_ok(response) {
		content_ok = response.match(directResponseRegexp);
		work_response = response;
		work_response = work_response.replace(/{time}/g, "12345678");
		work_response = work_response.replace(/{rssi}/g, "1234");
		work_response = work_response.replace(/{tapid}/g, "12345678");
		size = work_response.length;
		size_ok = size === 16;
		return content_ok && size_ok;
	}
	function get_conf(handleData) {
		//get data configuration json
		$.ajax({
			type: 'GET',
			url: 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration',
			success: function (data) {
				handleData(data);
			},
			async: false
		});
	}
	//get words between {}
	function splitString(texte) {
		const regex = /\{(.*?)\}/g;
		// \{(.*?))\} <---- try it
		const str = texte;
		let m;
		var ret = [];
		while ((m = regex.exec(str)) !== null) {
			// To avoid infinite loops with zero-width matches
			if (m.index === regex.lastIndex)
				regex.lastIndex++;
			// Copy the result of match in ret for group 1 (match whitout braces)
			m.forEach((match, groupIndex) => {
				if (groupIndex === 1)
					ret.push(match);
			});
		}
		return (ret);
	}
	//check variables format
	function checkVariables(base, data) {
		var tabValues = splitString(data);
		var len = base.length;
		var tabError = [];
		if (tabValues !== null) {
			tabValues.forEach(function (item) {
				var error = i = 0;
				for (i = 0; i < len; i++) {
					if (!(item === base[i]))
						error += 1;
					if (error === len)
						tabError.push(item);
				}
			});
		}
		return (tabError);
	}
	//display error message for variables
	function displayErrorMsg(errorTab) {
		var i = 0;
		if (errorTab.length != 0) {
			for (i = 0; i <= errorTab.length - 1; i++) {
				if (errorTab[i] == "")
					errorTab[i] = "{empty}";
			}
		}
		$.notify.addStyle('ned', {
			html: "<div><span data-notify-text/>" + LBL_PROBLEM_URL_DATA + "'" + "<b>" + errorTab + "</b>" + "'" + " to match with the available variables" + "</div>",
			classes: {
				base: {
					"white-space": "nowrap",
					"background-color": "#FA5537",
					"padding": "30px",
					"margin-top": "100px",
					"border-style": "solid",
					"border-width": "1px",
					"border-color": "black",
					"color": "white"
				}
			}
		});
		$.notify(' ', {
			style: 'ned',
			autoHideDelay: 12000
		});
	}
	function displayErrorPattern() {
		$.notify.addStyle('ned', {
			html: "<div><span data-notify-text/> Invalid URL. Check the patterns </div>",
			classes: {
				base: {
					"white-space": "nowrap",
					"background-color": "#FA5537",
					"padding": "30px",
					"margin-top": "100px",
					"border-style": "solid",
					"border-width": "1px",
					"border-color": "black",
					"color": "white"
				}
			}
		});
		$.notify(' ', {
			style: 'ned',
			autoHideDelay: 3000
		});
	}

	// general function to display errors
	function displayError(href, datas, spanToDisplay) {
		if (datas.length != 0)
			displayErrorMsg(datas);
		if (href == null)
			displayErrorHttp(href, spanToDisplay);
	}
	function getModel() {
		return this.model;
	}

	function checkEmptyPattern(dataUrl, ackUrl, statusUrl) {
		return (dataUrl === "" && ackUrl === "" && statusUrl === "");
	}
	// click on CANCEL button into callbacks page
	$('#validate-cancel-callbacks').on('click', function (e) {
		e.preventDefault();
		$('#link_callbacks').click();
	});

	// click on OK button into callbacks page
	$('#validate-callbacks').on('click', function (e) {
		e.preventDefault();
		var output = getModel();
		$('#infoErrorBody-data').hide();
		$('#infoErrorBody-ack').hide();
		$('#infoErrorBody-status').hide();
		if (!isNewCb) {
			output.callbacks = vModel.getValuesCallbacks(superIndex, output);
		}
		else {
			output.callbacks.push(vModel.getValuesNewCallbacks());
		}
		// TODO: factoring statements
		var isError = false;
		var isEmptyPattern = false;
		console.log('what :', isEmptyPattern);
		var isValid = is_response_ok($("#downlink").val());

		isError = checkCustomVariables("#config-custom-payload-data", "#config-custom-ERROR-data");
		isEmptyPattern = checkEmptyPattern($("#urlPattern-data").val(), $("#urlPattern-ack").val(), $("#urlPattern-status").val());
		console.log('what :', isEmptyPattern);
		if (isEmptyPattern) {
			isError = true;
			displayErrorPattern();	
		}
		if ($("#callbacks #channel-data").val() !== "BATCH-URL") {
			var errorUrlData = checkVariables(dataCustomList, $("#urlPattern-data").val());
			var errorLineData = checkVariables(dataCustomList, $("#linePattern-data").val());
			var errorBodyData = checkVariables(dataCustomList, $("#body_text_data").val());
		}
		else {
			var errorUrlData = checkVariables(batchList, $("#urlPattern-data").val());
			var errorLineData = checkVariables(dataCustomList, $("#linePattern-data").val());
			var errorBodyData = checkVariables(dataCustomList, $("#body_text_data").val());
		}
		if ($("#callbacks #channel-ack").val() !== "BATCH-URL") {
			var errorUrlAck = checkVariables(ackList, $("#urlPattern-ack").val());
			var errorLineAck = checkVariables(ackList, $("#linePattern-ack").val());
			var errorBodyAck = checkVariables(ackList, $("#body_text_ack").val());
		}
		else {
			var errorUrlAck = checkVariables(batchList, $("#urlPattern-ack").val());
			var errorLineAck = checkVariables(ackList, $("#linePattern-ack").val());
			var errorBodyAck = checkVariables(ackList, $("#body_text_ack").val());
		}
		if ($("#callbacks #channel-status").val() !== "BATCH-URL") {
			var errorUrlStatus = checkVariables(statusList, $("#urlPattern-status").val());
			var errorLineStatus = checkVariables(statusList, $("#linePattern-status").val());
			var errorBodyStatus = checkVariables(statusList, $("#body_text_status").val());
		}
		else {
			var errorUrlStatus = checkVariables(batchList, $("#urlPattern-status").val());
			var errorLineStatus = checkVariables(statusList, $("#linePattern-status").val());
			var errorBodyStatus = checkVariables(statusList, $("#body_text_status").val());
		}
		var hrefUrlData = getPattern($("#urlPattern-data").val());
		var hrefUrlAck = getPattern($("#urlPattern-ack").val());
		var hrefUrlStatus = getPattern($("#urlPattern-status").val());

		if (errorUrlData.length != 0 || (hrefUrlData == null && $("#urlPattern-data").val() != "")) {
			isError = true;
			displayError(hrefUrlData, errorUrlData, "#infoErrorUrl-data");
		}
		if (errorLineData && errorLineData.length != 0) {
			isError = true;
			displayErrorMsg(errorLineData);
		}
		if (errorBodyData.length != 0) {
			isError = true;
			$('#infoErrorBody-data').show();
			displayErrorMsg(errorBodyData);
		}
		if (errorUrlAck.length != 0 || (hrefUrlAck == null && $("#urlPattern-ack").val() != "")) {
			isError = true;
			displayError(hrefUrlAck, errorUrlAck, "#infoErrorUrl-ack");
		}
		if (errorLineAck && errorLineAck.length != 0) {
			isError = true;
			displayErrorMsg(errorLineAck);
		}
		if (errorBodyAck.length != 0) {
			isError = true;
			$('#infoErrorBody-ack').show();
			displayErrorMsg(errorBodyAck);
		}
		if (errorUrlStatus.length != 0 || (hrefUrlStatus == null && $("#urlPattern-status").val() != "")) {
			isError = true;
			displayError(hrefUrlStatus, errorUrlStatus, "#infoErrorUrl-status");
		}
		if (errorLineStatus && errorLineStatus.length != 0) {
			isError = true;
			displayErrorMsg(errorLineStatus);
		}
		if (errorBodyStatus.length != 0) {
			isError = true;
			$('#infoErrorBody-status').show();
			displayErrorMsg(errorBodyStatus);
		}
		if ((!isValid && $("#downlinkMode").val() == "DIRECT")) {
			isError = true;
			//NOTIFICATION NEW VERSION
			$.notify.addStyle('ned', {
				html: "<div><span data-notify-text/>" + LBL_PROBLEM_DATA + "</div>",
				classes: {
					base: {
						"white-space": "nowrap",
						"background-color": "#FA5537",
						"padding": "30px",
						"margin-top": "100px",
						"border-style": "solid",
						"border-width": "1px",
						"border-color": "black",
						"color": "white"
					}
				}
			});

			$.notify(' ', {
				style: 'ned',
				autoHideDelay: 5000
			});
		}
		if (isError === false) {
			vModel.postConf(output).then(function () {
				nbRowTable = 0;
				isNewCb = false;
				$('.table tbody tr').remove();
				get_conf(function (output) {
					set_conf(output);
					loadTableCallbacks(output);
				});
				SetCookie("where", "callbacks");
			});
		}
		else if (isNewCb) {
			output.callbacks.pop();
		}
	});
}
