//var proxy_reg = /^(https?:)(\/\/)(.*):(.*)@([\w.]+):(\d+)/g;
var proxy_reg = /^(https?:\/\/)(.*)/g;
var proxy_conf = {};

var ctrlConnection = function (vModel) {
    this.model = vModel;
    function get_conf(handleData) {
        //get data configuration json
        $.ajax({
            type: 'GET',
            url: 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration',
            success: function (data) {
                handleData(data);
            }
        });
    }
    function set_conf(conf) {
        this.model = conf;
    }
    function loadConnection() {
        SetCookie("where", "connection");
        $('#radio').hide();
        $('#devices').hide();
        $('#callbacks').hide();
        $('#connection').show();
        $('ul .radioLi').removeClass("left-nav-selected");
        $('ul .devicesLi').removeClass("left-nav-selected");
        $('ul .callbacksLi').removeClass("left-nav-selected");
        $('ul .connectionLi').addClass("left-nav-selected");
        setProxyValues();
    }
    function setProxyValues() {
        var items = this.model;
        $("#connection #uprgade-proxy").val(items.proxy.upgrade_proxy);
        $("#connection #callbacks-proxy").val(items.proxy.callbacks_proxy);
    }
    function isValidProxy(str) {
        var match = str.match(proxy_reg);
        return match;
    }
    // click on the left menu (CONNECTION)
    $('#link_connection').on('click', function (e) {
        e.preventDefault();
        get_conf(function (output) {
            set_conf(output);
            var ret = control_before_quit(output, document.cookie);
            if ((ret && (confirm(LBL_NOT_SAVED))) || !ret) {
                loadConnection();
            }
        })
    });

     // click on CANCEL button in the proxy page
     $('#validate-cancel-connection').on('click', function (e) { 
        e.preventDefault();
        setProxyValues();
     });


    // click on SAVE button into proxy page
    $('#validateConnection').on('click', function (e) {
        e.preventDefault();
        $.getJSON(URL_CONF, function (data) {
            proxy_conf = data;
        }).then(function () {
            var cb_proxy = $("#connection #callbacks-proxy").val();
            var up_proxy = $("#connection #uprgade-proxy").val();
            var match1 = isValidProxy(cb_proxy);
            var match2 = isValidProxy(up_proxy);
            if ((match1 === null && cb_proxy !== '') || (match2 === null && up_proxy !== '')) {
                $.notify.addStyle('ned_error', {
                    html: "<div><span data-notify-text/></div>",
                    classes: {
                        base: {
                            "white-space": "nowrap",
                            "background-color": "#FA5537",
                            "padding": "30px",
                            "margin-top": "100px",
                            "border-style": "solid",
                            "border-width": "1px",
                            "border-color": "black",
                            "color": "white"
                        }
                    }
                });
                $.notify('Your proxy settings do not match the following syntax\n\nhttp(s)://<user>:<password>@<domain name>:<port>', {
                    style: 'ned_error',
                    autoHideDelay: 4000,
                    clickToHide: true
                });
            }
            else {
                proxy_conf.proxy['callbacks_proxy'] = cb_proxy;
                proxy_conf.proxy['upgrade_proxy'] = up_proxy;
                vModel.postConf(proxy_conf);
            }
        });
    });
}
