var ctrlDevices = function (vModel, configuration) {
	this.conf = configuration.configuration;

	var getQueryString = function (field, url) {
		var href = url ? url : window.location.href;
		var reg = new RegExp('[?&]' + field + '=([^&#]*)', 'i');
		var string = reg.exec(href);
		return string ? string[1] : null;
	}

	// click on Cancel button in the radio page
	$('#devices #validate-cancel-devices').on('click', function (e) {
		e.preventDefault();
		loadDevices();
	  });

	function loadDevices() {
		SetCookie("where", "devices");
		var cpt = 1;

		for (var i = 1; i <= vModel.MAX_DEVICES; i++) {
			$('#devices #device' + i + '').val("");
			$('#devices #nameDevice' + i + '').val("");
		}
		get_conf(function (output) {
			$.each(output.devices, function (key, val) {
				$('#devices #device' + cpt + '').val(val.identifier);
				$('#devices #nameDevice' + cpt + '').val(val.name);
				cpt++;
			});
		});
		$('#radio').hide();
		$('#callbacks').hide();
		$('#connection').hide();
		$('#devices').show();
		$('ul .devicesLi').addClass("left-nav-selected");
		$('ul .radioLi').removeClass("left-nav-selected");
		$('ul .callbacksLi').removeClass("left-nav-selected");
		$('ul .connectionLi').removeClass("left-nav-selected");
	}

	// click on the left menu (DEVICES)
	$('#link_devices').on('click', function (e) {
		e.preventDefault();
		get_conf(function (output) {
			set_conf(output);
			var ret = control_before_quit(output, document.cookie);
			if ((ret && (confirm(LBL_NOT_SAVED))) || !ret) {
				loadDevices();
			}
		});
	});

	// click on OK button into devices page
	$('#devices #validateDevice').on('click', function (e) {
		e.preventDefault();
		get_conf(function (output) {
			set_conf(output);
			output.devices = configuration.getValuesDevices();
			var tab_devices = [];
			var list_not_hex = "";
			var passed = false;
			var hex_string = true;
			for (var i = 0; i < output.devices.length; i++) {
				tab_devices.push(output.devices[i].identifier);
			}
			for (i = 0; i < tab_devices.length; i++) {
				var isValid = (tab_devices[i]).match("^(?:0[xX])?[0-9a-fA-F]{1,8}$");
				if (!isValid) {
					hex_string = false;
					list_not_hex += tab_devices[i] + " ";
				}
				if (tab_devices.indexOf(tab_devices[i]) !== i) {
					passed = true;
					$("#device" + (i + 1)).attr("class", "error");

				}
			}
			if (passed == false && hex_string == true) {
				for (var i = 1; i <= vModel.MAX_DEVICES; i++) {
					$("#device" + i).removeAttr("class");
				}
				configuration.postConf(output);
				get_conf(function (output) {
					set_conf(output);
				});
			} else if (passed == true) {
				$.notify.addStyle('ned', {
					html: "<div><span data-notify-text/>Problem same identifier</div>",
					classes: {
						base: {
							"white-space": "nowrap",
							"background-color": "#FA5537",
							"padding": "30px",
							"margin-top": "100px",
							"border-style": "solid",
							"border-width": "1px",
							"border-color": "black",
							"color": "white"
						}
					}
				});

				$.notify(' ', {
					style: 'ned',
					autoHideDelay: 5000,
					clickToHide: true
				});
			} else {
				$.notify.addStyle('ned', {
					html: "<div><span data-notify-text/>Problem some identifiants do not match hexadecimal format on 4 bytes max(" + list_not_hex + ")</div>",
					classes: {
						base: {
							"white-space": "nowrap",
							"background-color": "#FA5537",
							"padding": "30px",
							"margin-top": "100px",
							"border-style": "solid",
							"border-width": "1px",
							"border-color": "black",
							"color": "white"
						}
					}
				});

				$.notify(' ', {
					style: 'ned',
					autoHideDelay: 5000,
					clickToHide: true
				});
			}
		});
	});

	function set_conf(conf) {
		this.conf = conf;
	}

	function get_conf(handleData) {
		//get data configuration json
		$.ajax({
			type: 'GET',
			url: 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration',
			success: function (data) {
				handleData(data);
			}
		});
	}
}
