var ctrlRadio = function (vModel) {
  this.model = vModel;
  var myOther = {};
  var otherIndex = 0;

  myOther = vModel.configuration.radio;
  for (var i = 0, len = myOther.length; i < len; i++) {
    if (myOther[i]["Other"])
      otherIndex = i;
  }

  function loadRadio() {
    setSelectOperatingZone();
    get_conf(function (output) {
      $("#radio #operating-zone option[value='" + output.radio_choice + "']").attr("selected", "selected");
      $("#radio #operating-zone").change();
      if (output.radio_choice == "Other") {
        $('#radio #uplink-frequency').removeAttr("disabled");
        $('#radio #downlink-frequency').removeAttr("disabled");
        $('#radio #bit-rate').removeAttr("disabled");
      }
    });
    SetCookie("where", "radio");
    $('#devices').hide();
    $('#callbacks').hide();
    $('#connection').hide();
    $('#radio').show();
    $('ul .radioLi').addClass("left-nav-selected");
    $('ul .devicesLi').removeClass("left-nav-selected");
    $('ul .callbacksLi').removeClass("left-nav-selected");
    $('ul .connectionLi').removeClass("left-nav-selected");
  }

  // click on the left menu (RADIO)
  $('#link_radio').on('click', function (e) {
    e.preventDefault();
    get_conf(function (output) {
      set_conf(output);
      var ret = control_before_quit(output, document.cookie);
      if ((ret && (confirm(LBL_NOT_SAVED))) || !ret) {
        loadRadio();
      }
    });
  });

  // Load radio page
  function loadConfiguration() {
    SetCookie("where", "radio");
    $('#content_configuration').load("configuration.html").detach('#radio').appendTo('#content_configuration').css('display', 'block');
    $('#content_messages').empty();
    items = vModel.configuration;
    var choice = items.radio_choice;
    $("#radio #operating-zone").children().remove().end();
    $.each(items.operatingZoneValues, function (key, val) {
      var opt = document.createElement('option');
      opt.textContent = val.name;
      opt.value = val.name;
      $("#radio #operating-zone").append(opt);
    });
    $("#radio #operating-zone option[value='" + choice + "']").attr("selected", "selected");
    $("#radio #operating-zone").change();
  }

  var items = {};
  $('#link_configuration').unbind('click').on('click', function (e) {
    e.preventDefault();
    get_conf(function (output) {
      set_conf(output);
      $("#messagesLi").removeClass("permahoover");
      $("#configurationLi").addClass("permahoover");
      if (!document.cookie.includes("radio")) {
        var ret = control_before_quit(output, document.cookie);
        if (ret) {
          if (confirm(LBL_NOT_SAVED)) {
            loadConfiguration();
          }
        }
        else {
          loadConfiguration();
        }
      }
      else {
        loadConfiguration();
      }
    });
  })
  $("#radio #operating-zone").unbind("change").change(function () {
    var cpt = 1;
    get_conf(function (output) {
      $.each(output.devices, function (key, val) {
        $('#devices #device' + cpt + '').val(val.identifier);
        $('#devices #nameDevice' + cpt + '').val(val.name);
        cpt++;
      });
    }

    );
    var choice = $("#radio #operating-zone").val();
    $("#radio #operating-zone[value='" + choice + "']").attr("selected", "selected");
    if (choice != "Other") {
      setRadioValue();
    }
    else {
      $('#radio #uplink-frequency').removeAttr("disabled");
      $('#radio #uplink-frequency').val(vModel.configuration.radio[otherIndex].Other.uplink);
      $('#radio #downlink-frequency').removeAttr("disabled");
      $('#radio #downlink-frequency').val(vModel.configuration.radio[otherIndex].Other.downlink);
      $('#radio #bit-rate').val(vModel.configuration.radio[otherIndex].Other.bitRate);
      $('#radio #bit-rate').removeAttr("disabled");
    }
  });

  // filling bit rate select
  function setSelectBiteRate() {
    $("#radio #bit-rate").children().remove().end();
    $.each(vModel.configuration.bitRateValues, function (key, val) {
      $("#radio #bit-rate").append("<option value=" + val + ">" + val + "</option>");
    });
  }

  // set the bite rate value
  function setRadioValue() {
    var choice = $("#radio #operating-zone").val();
    setSelectBiteRate();
    $.each(vModel.configuration.radio, function (key, val) {
      $.each(val, function (key2, val2) {
        if (choice !== undefined) {
          if (choice.localeCompare(key2) == 0) {
            $('#radio #uplink-frequency').val(val2.uplink);
            $('#radio #uplink-frequency').attr("disabled", "true");
            $('#radio #downlink-frequency').val(val2.downlink);
            $('#radio #downlink-frequency').attr("disabled", "true");
            $("#radio #bit-rate option[value='" + val2.bitRate + "']").attr("selected", "selected");
            if (choice != "Other") {
              $('#radio #bit-rate').attr("disabled", "true");
            }
            else {
              $('#radio #bit-rate').removeAttr("disabled");
            }
          }
        }
      });
    });
  }

  function set_conf(conf) {
    this.conf = conf;
  }

  function get_conf(handleData) {
    //get data configuration json
    return $.ajax({
      type: 'GET',
      url: 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration',
      success: function (data) {
        handleData(data);
      }
    });
  }
  function is_digit(str) {
    return /^\d+$/.test(str);
  }

  function set_values_from_conf() {
  /*This function asks the for the configuration file, and sets the values of the radio
  depending on what is set on it.  */

    
    let conf = undefined;
    $.when(get_conf(function (output) {
      set_conf(output);
      conf = output;
    })).done(function(reply){
      let choice = conf.radio_choice;
      setSelectOperatingZone();
      $("#radio #operating-zone option[value='" + choice + "']").attr("selected", "selected");
      $("#radio #operating-zone").change();
      setRadioValue();
      if (choice == "Other") {
        $('#radio #uplink-frequency').removeAttr("disabled");
        $('#radio #downlink-frequency').removeAttr("disabled");
        $('#radio #bit-rate').removeAttr("disabled");
      }
    });
  }

  // click on OK button into radio page
  $('#radio #validate').on('click', function (e) {
    e.preventDefault();
    get_conf(function (output) {
      set_conf(output);
      output.radio = vModel.getValuesRadio();
      output.radio_choice = $("#radio #operating-zone").val();
      var downlinkOther = output.radio[otherIndex].Other.downlink;
      var uplinkOther = output.radio[otherIndex].Other.uplink;
      if (output.radio_choice === "Other" && (downlinkOther === "" || uplinkOther === "" || !is_digit(downlinkOther) || !is_digit(uplinkOther))) {
        //NOTIFICATION NEW VERSION
        $.notify.addStyle('ned_error', {
          html: "<div><span data-notify-text/></div>",
          classes: {
            base: {
              "white-space": "nowrap",
              "background-color": "#FA5537",
              "padding": "30px",
              "margin-top": "100px",
              "border-style": "solid",
              "border-width": "1px",
              "border-color": "black",
              "color": "white"
            }
          }
        });
        $.notify('UPLINK and/or DOWNLINK format error', {
          style: 'ned_error',
          clickToHide: true
        });

      }
      else {
        vModel.postConf(output);
        get_conf(function (output) {
          set_conf(output);
        });
      }
    });
  });


  // click on Cancel button in the radio page
  $('#radio #validate-cancel-radio').on('click', function (e) {
    e.preventDefault();
    set_values_from_conf();
  });

  // filling bit rate select
  function setSelectOperatingZone() {
    $("#radio #operating-zone").children().remove().end();
    $.each(vModel.configuration.operatingZoneValues, function (key, val) {
      var opt = document.createElement('option');
      opt.textContent = val.name;
      opt.value = val.name;
      $("#radio #operating-zone").append(opt);
    });
  }

  //init launch configuration page
  set_values_from_conf();
  /* var choice = vModel.configuration.radio_choice;
  setSelectOperatingZone();
  $("#radio #operating-zone option[value='" + choice + "']").attr("selected", "selected");
  $("#radio #operating-zone").change();
  setRadioValue();
  if (choice == "Other") {
    $('#radio #uplink-frequency').removeAttr("disabled");
    $('#radio #downlink-frequency').removeAttr("disabled");
    $('#radio #bit-rate').removeAttr("disabled");
  } */
}
