var URL_CONF = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration';
/* init */
$.getJSON(URL_CONF, function (data) {
    $('#content_configuration').load("configuration.html");
    $('#content_messages').empty();
    //    $('#radio').show();
    var choice = data.radio_choice;
    $("#radio #operating-zone").children().remove().end();
    $.each(data.operatingZoneValues, function (key, val) {
        var opt = document.createElement('option');
        opt.textContent = val.name;
        opt.value = val.name;
        $("#radio #operating-zone").append(opt);
    });
    $("#radio #operating-zone option[value='" + choice + "']").attr("selected", "selected");
    $("#radio #operating-zone").change();
});
var URL_SATURATION = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/saturation';
$.getJSON(URL_SATURATION, function (data) {
    if (data.authentication === false) {
        $('#auth-action').attr('checked', false);
        $('#auth-disabled').show();
        $('#auth-enabled').hide();
    }
    else {
        $('#auth-disabled').hide();
        $('#auth-enabled').show();
    }
    $("#auth-action").on('click', function (e) {
        switch (data.authentication) {
            case false:
                $.notify.addStyle('ned', {
                    html: "<div ><span data-notify-text/>Enabling Authentication...</div>",
                    classes: {
                        base: {
                            "white-space": "nowrap",
                            "background-color": "#8024FF",
                            "padding": "30px",
                            "margin-top": "100px",
                            "margin-right": "50px",
                            "border-style": "solid",
                            "border-width": "1px",
                            "border-color": "black",
                            "color": "white"
                        }
                    }
                });
                $.notify(' ', {
                    style: 'ned',
                    autoHideDelay: 3000,
                    autoHide: true,
                    clickToHide: true,
                });
                data.authentication = true;
                break;
            default:
                $.notify.addStyle('ned', {
                    html: "<div ><span data-notify-text/>Downlink messages won't be authenticated by the device under test" +
                        "<br><br><button class='ok'>Ok</button></div>",
                    classes: {
                        base: {
                            "white-space": "nowrap",
                            "background-color": "#4182FF",
                            "padding": "30px",
                            "margin-top": "100px",
                            "margin-right": "50px",
                            "border-style": "solid",
                            "border-width": "1px",
                            "border-color": "black",
                            "color": "white",
                        }
                    }
                });
                $.notify(' ', {
                    style: 'ned',
                    autoHideDelay: 5000,
                    autoHide: true,
                    clickToHide: true,
                });
                data.authentication = false;
        }
        $.ajax({
            url: URL_SATURATION,
            type: "POST",
            dataType: "json",
            data: JSON.stringify(data),
            success: function (code_html, statut) {
                console.log("Authentication status has been changed");
            },
            error: function (resultat, statut, erreur) {
                console.log("Fail to change authentication status");
            }
        });
    });
});
check_install();
check_saturation();
