var DELAY_NOTIF = 40000;
var messages = [];
var i = 1;
var SIZE_MAX = 100;
var URL = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/messages';
var URL_CONF = 'http://' + window.location.hostname + ':' + window.location.port + '/ned/configuration';
var arrow = [[], []];
var columns = "";
var map = {};
var l_lang = "";

l_lang = window.navigator.userLanguage || window.navigator.language;
moment.locale(l_lang);
console.log("Your locale is set in: " + l_lang);

//path IE
if (!String.prototype.includes) {
	String.prototype.includes = function () {
		'use strict';
		jQuery.ajaxSetup({
			cache: false
		});
		return String.prototype.indexOf.apply(this, arguments) !== -1;
	};
}

//create cookie
function SetCookie(name, value) {
	document.cookie = name + "=" + escape(value);
}

$("#turn").unbind('click').on('click', function (e) {
	e.preventDefault();
	if (readCookie("turn_off") == "false") {
		if (confirm(LBL_STOP_SERVER)) { // Clic sur OK
			SetCookie("turn_off", "true");
			$.ajax({
				url: "http://" + window.location.hostname + ":" + window.location.port + "/ned/exit",
				type: "GET",
				success: function (code_html, statut) {
					var myWindow = window.open("", "_self");
					myWindow.document.write();
					myWindow.document.close("", "_self");
					$.blockUI({
						message: LBL_SERVER_STOPPED,
						css: {
							"cursor": "auto",
							"white-space": "nowrap",
							"background-color": "#8024FF",
							"padding": "30px",
							"margin-top": "100px",
							"border-style": "solid",
							"border-width": "1px",
							"border-color": "black",
							"color": "white",
							"width": "600px",
							"opacity": 0.5
						},
						overlayCSS: {
							"cursor": 'auto'
						}
					});
				},
				error: function (resultat, statut, erreur) { }
			});
		} else {
			return;
		}
	}

});

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for (var i = 0; i < ca.length; i++) {
		var c = ca[i];
		while (c.charAt(0) == ' ')
			c = c.substring(1, c.length);
		if (c.indexOf(nameEQ) == 0)
			return c.substring(nameEQ.length, c.length);
	}
	return null;
}

var getQueryString = function (field, url) {
	var href = url ? url : window.location.href;
	var reg = new RegExp('[?&]' + field + '=([^&#]*)', 'i');
	var string = reg.exec(href);
	return string ? string[1] : null;
};

if (getQueryString("phantomJS") === null) {
	var refresh = false;
	$(window).keydown(function (event) {
		if (event.keyCode == 116) { // User presses F5 to refresh
			refresh = true;
			event.returnValue = '';
			return event.returnValue;
		}
	});

	var confirmOnLeave = function () {
		if (refresh == false) {
			if (navigator.appCodeName == "Mozilla") {
				$(window).on('beforeunload', function (e) {
					if (e.keyCode !== 116) {
						msg = LBL_EXIT;
						return msg;
					}
				});
			} else {
				window.onbeforeunload = function (e) {
					if (e.keyCode !== 116) {
						e = e || window.event;
						msg = LBL_EXIT;

						// For IE and Firefox
						if (e) {
							e.returnValue = msg;
						}

						// For Chrome and Safari
						return msg;
					}
				};
			}
		}

	};
	// //
	if (refresh === false) {
		// message de confirmation personnalisé
		confirmOnLeave();
	}
}

function find_first_element_dont_care_about_undefined(multi_callbacks_array,equality_condition){
	/*
	The .find is a useful javascript function that returns the first instance 
	of an equality condition.
	The .find is however not equiped to deal with objects that might not have
	a specific attribute!
	
	So a special find function had to be constructed.

	This function is only used for the parseCallback function
	*/
	var callback_to_return = undefined;

	//Note to future javascript programmers, the .ForEach method is horrid
	//The old ways are the best ways
	for (index = 0; index < multi_callbacks_array.length; ++index) {
		try {
			if (multi_callbacks_array[index].status[1].status_down === equality_condition) {
				callback_to_return = multi_callbacks_array[index];
			}
		}
		catch(err){
			// Yes yes, I know all callbacks might not have a status[1]!
		}
	}
	return callback_to_return
}


function parseCallback(multicbs, index) {
	/* 
	This function parses through a list of multi callbacks and then awards the, a status and a tooltip.
	This status and tooltip are then used to determine what colour the little arrow to the right
	on the callback menu should assume, and what it should say when a user hovers over it with
	a mouse.
	
	For the uplink arrow (the leftmost arrow) the function finds the first instance (if it exists)
	of the all types of status's. It then displays the colour depending on a hierarchy,

	Red overides N number of all colours, orange all but red, and green overrides grey.

	For the downlink the process is slightly trickier, and is described bellow
	
	*/
	var upRed,
		upOrange,
		upGreen,
		upGrey,
		upStatus;

	
	//Attempt to find the first instance of a status up for every type!
	upRed = multicbs.find(cb => cb.status[0].status_up === "KO");
	upOrange = multicbs.find(cb => cb.status[0].status_up === "WAITING");
	upGreen = multicbs.find(cb => cb.status[0].status_up === "OK");
	upGrey = multicbs.find(cb => cb.status[0].status_up === "NO_CB");

	/* Now we simply obey a hierarchy.
	   If there is even a single upRed, that means that one of the multicbs has
	   a up status value of Red, which overrides all other solutions!

	   If there is an Orange, then that overrides all other Green/Grey solutions

	   And so on...
	*/
	if (upRed !== undefined) {
		upStatus = "KO";
	} else if (upOrange !== undefined) {
		upStatus = "WAITING";
	} else if (upGreen !== undefined) {
		upStatus = "OK";
	} else {
		upStatus = "NO_CB";
	}

	//We now define the multicbs[0] to have the upstatus of the hierarchy,
	//So it can be easily displayed!
	multicbs[0].status[0].status_up = upStatus;

	//Now if any of the multiple callbacks have a down arrow then...
	if (multicbs.find(cb => cb.status[1] !== undefined)) {
		let downRed,
			downOrange,
			downGreen,
			downGrey,
			downStatus,
			tooltipDown;
			
		//Similar process to uplink at the start.
		downRed = find_first_element_dont_care_about_undefined(multicbs,"KO");
		downOrange = find_first_element_dont_care_about_undefined(multicbs,"WAITING");
		downGreen = find_first_element_dont_care_about_undefined(multicbs,"OK");
		downGrey = find_first_element_dont_care_about_undefined(multicbs,"NO_CB");
		/* downRed = multicbs.find(cb => cb.status[1].status_down === "KO");
		downOrange = multicbs.find(cb => cb.status[1].status_down === "WAITING");
		downGreen = multicbs.find(cb => cb.status[1].status_down === "OK");
		downGrey = multicbs.find(cb => cb.status[1].status_down === "NO_CB"); */
		if (downRed !== undefined) {
			/* downlink_enabled = true; */
			downStatus = "KO";
			tooltipDown = downRed.status[1].tooltip;
		} else if (downOrange !== undefined) {
			/* downlink_enabled = true; */
			downStatus = "WAITING";
			tooltipDown = downOrange.status[1].tooltip;
		} else if (downGreen !== undefined) {
			/* downlink_enabled = true; */
			tooltipDown = downGreen.status[1].tooltip;
			downStatus = "OK";
		} else {
			tooltipDown = "Downlink mode is disabled"
			downStatus = "NO_CB";
		}
		/* This callback is called once every 20 seconds or so. As such, we need to make sure
		   if the OK answer has come forth from the device!
		   To do this, we check if previously the status was waiting,
		   we then check if there is no need to display the status as waiting if the 
		   current list of multiple callbacks features only grey or green 
		   
		*/
		if (downStatus === "WAITING") {
			let all_ok = true;
			multicbs.forEach(function (element, index) {
				if (element.status.length === 2) {
					if (element.status[1].status_down !== "OK" && element.status[1].status_down !== "NO_CB") {
						all_ok = false;
					}
				}
			});

			//Once we've checked to see if every status is either green or grey, we can go forth
			//and say that the status is now green!
			if (all_ok) {
			tooltipDown = "200";
			downStatus = "OK";
			}

		} 
		//Just in case the first callback on the array doesn't have a down arrow...
		if (multicbs[0].status[1] === undefined ){
			/*
			Attention! If the status[1] doesn't exist, we naturally need to create it so it can
			be displayed correctly in the graphics!
			A deep copy of status[0] might then be desirable
			(JSON.parse(JSON.stringify(obj))). I have opted not to do that since status[0] and 
			status[1] are technically different "classes", their attributes are named differently.

			To not add a lot of unecessary complexity, the object is simply created there and then.
			(To future readers of the code: A classes.js might be very good for the sanity of this project)
			*/
			multicbs[0].status[1] = {"tooltip":"", "status_down":""};

		}
		multicbs[0].status[1].tooltip = tooltipDown;
		multicbs[0].status[1].status_down = downStatus;
		
	}

	return multicbs[0];
}

function parseData(obj) {
	if (obj.message.seqNumber === map.seqNumber && obj.message.device === map.deviceID)
		return true;
	return false;
}

callback = function (data) {
	$("tr[id^=device_]").remove();
	messages = [];
	if (data.length > 100) {
		data = data.slice(data.length - 100, data.length);
	}
	var data_bis = data.filter(callback => callback.type !== "cb_ack");
	var tempArray = [];
	var newData = [];
	var seqID = [];

	for (i = 0; i < data_bis.length; i++) {
		map.seqNumber = data_bis[i].message.seqNumber;
		map.deviceID = data_bis[i].message.device;
		map.cbID = data_bis[i].id;
		tempArray = data_bis.filter(parseData);
		if (seqID.includes(map.seqNumber) && seqID.includes(map.deviceID)) {
			continue;
		}
		newData.push(tempArray);
		seqID.push(map.seqNumber);
		if (!seqID.includes(map.deviceID)) {
			seqID.push(map.deviceID);
		}
	}
	var finalConf = [];

	finalConf = newData.map(parseCallback);
	finalConf.forEach(function (item) {
		var date = moment.unix(item.message.time).format("ll LTS");

		messages.push(item.message.device);
		arrow[0]["OK"] = "<a href='#' class='tooltip_right'><img src='../imagesv234/up.png' class='up'/><span>" + item.status[0].tooltip + "</span></a>";
		arrow[0]["KO"] = "<a href='#' class='tooltip_right'><img src='../imagesv234/up_error.png' class='up_error'/><span>" + item.status[0].tooltip + "</span></a>";
		arrow[0]["WAITING"] = "<a href='#' class='tooltip_right'><img src='../imagesv234/waiting.png' class='up_waiting'/><span>" + item.status[0].tooltip + "</span></a>";
		arrow[0]["NO_CB"] = "<a href='#' class='tooltip_right'><img src='../imagesv234/up_no_cb.png' class='up_no_cb'/><span>" + item.status[0].tooltip + "</span></a>";
		if (typeof (item.status[1]) === null || typeof (item.status[1]) === 'undefined') {
			item.status[1] = "null";
		}
		if (item.status[1] != "null" || typeof (item.status[1]) !== 'undefined') {
			arrow[1]["OK"] = "<a href='#' class='tooltip_left'><img src='../imagesv234/down.png' class='down'/><span>" + item.status[1].tooltip + "</span></a>";
			arrow[1]["KO"] = "<a href='#' class='tooltip_left'><img src='../imagesv234/down_error.png' class='down_error'/><span>" + item.status[1].tooltip + "</span></a>";
			arrow[1]["WAITING"] = "<a href='#' class='tooltip_left'><img src='../imagesv234/waiting_down.png' class='down_waiting'/><span>" + item.status[1].tooltip + "</span></a>";
			arrow[1]["NO_CB"] = "<a href='#' class='tooltip_left'><img src='../imagesv234/down_no_cb.png' class='down_no_cb'/><span>" + item.status[1].tooltip + "</span></a>";
		}
		item.message.device = item.message.device.toUpperCase();
		if (item.message.device.length < 4) {
			while (item.message.device.length < 4) {
				item.message.device = "0" + item.message.device;
			}
		}
		var columns = "";

		if (item.type == "cb_status") {
			if (!(isNaN(item.message.rssi))) {
				columns = "<tr class='ack_color' id=device_" + item.message.device + "><td id='deviceId' class='deviceNumber'>" + item.message.device + "</td><td id='dateMsg' class='value'>" + date + "</td> <td id='sequenceId' class='value'>" + item.message.seqNumber + "</td><td id='data' class='value'>" + item.message.payload + "<br />Temp : " + item.message.temp + "°C<br />VDD idle : " + item.message.vdd_idle + " mV<br />VDD tx : " + item.message.vdd_tx + " mV<br />RSSI : " + item.message.rssi.toFixed(1) + "</td><td id='LQI' class='reception_5'></td>";
			}
			else {
				columns = "<tr class='status_color' id=device_" + item.message.device + "><td id='deviceId' class='deviceNumber'>" + item.message.device + "</td><td id='dateMsg' class='value'>" + date + "</td> <td id='sequenceId' class='value'>" + item.message.seqNumber + "</td><td id='data' class='value'>" + item.message.payload + "<br />Temp : " + item.message.temp + "°C<br />VDD idle : " + item.message.vdd_idle + " mV<br />VDD tx : " + item.message.vdd_tx + " mV</td><td id='LQI' class='reception_5'></td>";
			}
		} else if (item.type == "cb_data") {
			columns = "<tr id=device_" + item.message.device + "><td id='deviceId' class='deviceNumber'>" + item.message.device + "</td><td id='dateMsg' class='value'>" + date + "</td> <td id='sequenceId' class='value'>" + item.message.seqNumber + "</td><td id='data' class='value'>" + item.message.data + "</td><td id='LQI' class='reception_5'></td>";
		}
		var result = "";

		if (item.status[0].tooltip !== "ack successful") {
			if (item.status[0].status_up !== "") {
				result = "<td id='callback'>" + arrow[0][item.status[0].status_up] + "</td>";
			}
			if (item.status[1] != "null" && typeof (item.status[1]) !== 'undefined') {
				result += "<td id='callback'>" + arrow[1][item.status[1].status_down] + "</td>";
			} else {
				result += "<td id='callback'><img class='empty'/></td>";
			}
			if (columns != "") {
				$(columns + result + "</tr>").insertAfter('#messages #msg_center .title');
			}
		}
	});
}

fetchData = function () {
	$("#messages #lang").val(l_lang);
	$.getJSON(URL, callback);
}

function deepCompare() {
	var i, l, leftChain, rightChain;

	function compare2Objects(x, y) {
		var p;

		// remember that NaN === NaN returns false
		// and isNaN(undefined) returns true
		if (isNaN(x) && isNaN(y) && typeof x === 'number' && typeof y === 'number') {
			return true;
		}
		// Compare primitives and functions.
		// Check if both arguments link to the same object.
		// Especially useful on the step where we compare prototypes
		if (x === y) {
			return true;
		}
		// Works in case when functions are created in constructor.
		// Comparing dates is a common scenario. Another built-ins?
		// We can even handle functions passed across iframes
		if ((typeof x === 'function' && typeof y === 'function') ||
			(x instanceof Date && y instanceof Date) ||
			(x instanceof RegExp && y instanceof RegExp) ||
			(x instanceof String && y instanceof String) ||
			(x instanceof Number && y instanceof Number)) {
			return x.toString() === y.toString();
		}
		// At last checking prototypes as good as we can
		if (!(x instanceof Object && y instanceof Object)) {
			return false;
		}
		if (x.isPrototypeOf(y) || y.isPrototypeOf(x)) {
			return false;
		}
		if (x.constructor !== y.constructor) {
			return false;
		}
		if (x.prototype !== y.prototype) {
			return false;
		}
		// Check for infinitive linking loops
		if (leftChain.indexOf(x) > -1 || rightChain.indexOf(y) > -1) {
			return false;
		}
		// Quick checking of one object being a subset of another.
		// todo: cache the structure of arguments[0] for performance
		for (p in y) {
			if (y.hasOwnProperty(p) !== x.hasOwnProperty(p)) {
				return false;
			}
			else if (typeof y[p] !== typeof x[p]) {
				return false;
			}
		}
		for (p in x) {
			if (y.hasOwnProperty(p) !== x.hasOwnProperty(p)) {
				return false;
			}
			else if (typeof y[p] !== typeof x[p]) {
				return false;
			}
			switch (typeof (x[p])) {
				case 'object':
				case 'function':

					leftChain.push(x);
					rightChain.push(y);

					if (!compare2Objects(x[p], y[p])) {
						return false;
					}

					leftChain.pop();
					rightChain.pop();
					break;

				default:
					if (x[p] !== y[p]) {
						return false;
					}
					break;
			}
		}
		return true;
	}
	for (i = 1, l = arguments.length; i < l; i++) {

		leftChain = []; //Todo: this can be cached
		rightChain = [];

		if (!compare2Objects(arguments[0], arguments[i])) {
			return false;
		}
	}
	return true;
}

function control_before_quit(model_loc, where) {
	var control_return = false;
	var cookie = where;
	var jsonValidate = {};

	if (this.conf == undefined) {
		this.conf = configuration.configuration;
	}
	if (cookie.includes("devices")) {
		jsonValidate.devices = configuration.getValuesDevices();
		if (this.conf.devices.length != jsonValidate.devices.length) {
			control_return = true;
		} else if (jsonValidate.devices.length > 0) {
			for (var i = 0; i < this.conf.devices.length; i++) {
				if (this.conf.devices[i]['identifier'] != jsonValidate.devices[i]['identifier'] ||
					this.conf.devices[i]['name'] != jsonValidate.devices[i]['name']) {
					control_return = true;
					break;
				}
			}
		}
	}
	if (cookie.includes("radio")) {
		if (this.conf.radio_choice !== $("#radio #operating-zone").val()) {
			control_return = true;
		} else if (this.conf.radio_choice == "Other") {
			if (this.conf.radio[6].Other.uplink !== $("#radio #uplink-frequency").val()) {
				control_return = true;
			} else if (this.conf.radio[6].Other.downlink !== $("#radio #downlink-frequency").val()) {
				control_return = true;
			} else if (this.conf.radio[6].Other.bitRate !== $("#radio #bit-rate").val()) {
				control_return = true;
			}
		}
	}
	if (cookie.includes("callbacks_edit")) {
		var callbackGetValues = configuration.getValuesCallbacks(readCookie("callbackID"));
		// console.log("get values: ", callbackGetValues);
		var callbackConf = model_loc.callbacks;
		var deepReturn = deepCompare(callbackGetValues, callbackConf);
		// console.log("conf: ", callbackConf);
		if (deepReturn === false) {
			control_return = true;
		}
	}
	if (cookie.includes("connection")) {
		var proxyValues = model_loc.proxy;
		if (proxyValues['callbacks_proxy'] !== $("#connection #callbacks-proxy").val() || proxyValues['upgrade_proxy'] !== $("#connection #uprgade-proxy").val()) {
			control_return = true;
		}
	}
	return control_return;
}
