#!/bin/bash

SNEK_VERSION="v234"
INSTALL_PATH="/opt/snek"
NOTIFIER='zenity'
OLD_LD_LIBRARY_PATH=$LD_LIBRARY_PATH
export LD_LIBRARY_PATH=$INSTALL_PATH
export GI_TYPELIB_PATH=$INSTALL_PATH
export PATH=.:$PATH

cd $INSTALL_PATH


function notify_user {
    which $NOTIFIER && LD_LIBRARY_PATH="$OLD_LD_LIBRARY_PATH" $NOTIFIER --warning --title "$2" --text "$1" || echo "Missing application to display messages ($NOTIFIER) ==> $1"
}

function is_device_connected {
    $INSTALL_PATH/foxctl
    RC=$?
    echo "RC=$RC"
    return $RC
}

function device_connected {
    nohup ./main_sigfox &
    #./main_sigfox
    sleep 3
    LD_LIBRARY_PATH="$OLD_LD_LIBRARY_PATH" python -mwebbrowser http://localhost:8085/static$SNEK_VERSION/index.html
}

function device_disconnected {
    notify_user  "Sigfox Network Emulator cannot be launched because no SDR dongle has been detected.\n
Solutions - Use the following steps:
1- Please insert SDR dongle in compatible USB port and then restart the application.\n2- Please unplug and replug the dongle and then restart the application.\n3- Please contact support.sigfox.com" "Sigfox Network Emulator" 
}

is_device_connected && device_connected || device_disconnected
